---
title: Query parameter quick reference
description: SCIM protocol filtering operators help you fine-tune requests that return a large number of items. The PingOne platform supports several SCIM operators. For the list of supported SCIM filtering operators, refer to Paging and ordering collections conventions).
component: pingone-api
page_id: pingone-api:platform:reference/query-parameter-quick-reference
canonical_url: https://developer.pingidentity.com/pingone-api/platform/reference/query-parameter-quick-reference.html
section_ids:
  endpoints-that-support-scim-filtering-expressions: Endpoints that support SCIM filtering expressions
  endpoints-that-support-resource-expansion: Endpoints that support resource expansion
  endpoints-that-support-ordering-by-attribute: Endpoints that support ordering by attribute
  endpoints-that-support-page-limits: Endpoints that support page limits
---

# Query parameter quick reference

SCIM protocol filtering operators help you fine-tune requests that return a large number of items. The PingOne platform supports several SCIM operators. For the list of supported SCIM filtering operators, refer to [Paging and ordering collections](paging-ordering-collections.html) conventions).

|   |                                                                                                                                                                                                                                                                                                   |
| - | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|   | PingOne endpoint operations may support only a subset of SCIM filtering operators. In addition, the service may allow filtering only on specific attributes. For example, the `/organizations` endpoint allows filtering only on the `name` attribute using only the `sw` (starts with) operator. |

This topic provides a quick reference to show the SCIM operators that apply to a given PingOne endpoint operation. It also provides information about endpoint operations that support the `limit` filter, the `order` filter, and the `expand` filter. For general information about page limits and collection ordering, refer to [Paging and ordering collections](paging-ordering-collections.html). For information about resource expansion, refer to the "Link expansion" section of [HTTP methods](../../foundations/conventions/pingone-api-requests.html#conventions-http-methods) conventions).

## Endpoints that support SCIM filtering expressions

The following endpoint operations allow filtering with the indicated attributes and operators. Refer to [Paging and ordering collections](paging-ordering-collections.html) conventions for SCIM operator names and descriptions.

| Endpoint                                                                           | SCIM operators by attribute                                                                                                                                                                                                                                                                                             |
| ---------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| [`/activeIdentityCounts`](../active-identity-counts.html)                          | \* `startDate`: ge\* `samplingPeriod`: eq                                                                                                                                                                                                                                                                               |
| [`/activities`](../audit-activities.html)                                          | \* `recordedat`: ge, gt, le, lt\* `correlationid`: eq\* `actors.client.id`: eq\* `actors.user.id`: eq\* `actors.user.name`: eq\* `resources.id`: eq\* `resources.type`: eq\* `resources.population.id`: eq\* `action.type`: eq                                                                                          |
| [`/applicationSignons`](../authentications-per-application.html)                   | \* `occurredAt`: ge                                                                                                                                                                                                                                                                                                     |
| [`/environments`](../environments.html)                                            | \* `name`: sw\* `id`: eq\* `organization.id`: eq                                                                                                                                                                                                                                                                        |
| [`/licenses`](../licenses.html)                                                    | \* `beginsAt`: lt                                                                                                                                                                                                                                                                                                       |
| [`/populations`](../populations.html)                                              | \* `name`: sw\* `id`: eq                                                                                                                                                                                                                                                                                                |
| [`/environment/{{envID}}/roles`](../roles/custom-roles/read-all-custom-roles.html) | \* `type`: eq                                                                                                                                                                                                                                                                                                           |
| [`/templates`](../notifications/notifications-templates.html)                      | \* `createdAt`: eq, ne, gt, ge, lt, le\* `updatedAt`: eq, ne, gt, ge, lt, le\* `default`: eq\* `deliveryMethod`: eq                                                                                                                                                                                                     |
| [`/totalIdentities`](../total-identities.html)                                     | \* `startDate`: eq\* `endDate`: eq                                                                                                                                                                                                                                                                                      |
| [`/userActivities`](../user-activities.html)                                       | \* `startDate`: eq, gt, ge, lt, le\* `endDate`: eq, gt, ge, lt, le                                                                                                                                                                                                                                                      |
| [`/users`](../users/users-1/read-all-users.html)                                   | \* `enabled`: eq\* `population.id`: eq\* `{{customStringAttributes}}`: eq, sw (refer to note below)\* `linkedAccounts[identityProvider.id eq "{{identityProviderID}}"]`\* `linkedAccounts[externalId eq "{{externalID}}"]`\* `memberOfGroups[id eq "{{memberOfGroupID}}"]`\* `memberOfGroups[type eq "{{typeString}}"]` |
| [`/users/{{userID}}/devices`](../../mfa/users/mfa-devices.html)                    | \* `status`: eq\* `type`: eq                                                                                                                                                                                                                                                                                            |

|   |                                                                                                                                                                                                                                                                                     |
| - | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|   | For string attributes (and string sub-attributes like `name.formatted`), the `eq` and `sw` operators are available. This includes custom string attributes added to the user schema. Attribute names are case-sensitive. Text inside quotes are used for a case-insensitive search. |

## Endpoints that support resource expansion

The following endpoint operations support resource expansion using the `expand={resource}` filter.

| Endpoint                                                                                                                                                     | Target resource                                                        |
| ------------------------------------------------------------------------------------------------------------------------------------------------------------ | ---------------------------------------------------------------------- |
| [`/environments`](../environments/read-all-environments.html)                                                                                                | \* `expand=billOfMaterials`                                            |
| [`/environments/{{envID}}`](../environments/read-one-environment.html)                                                                                       | \* `expand=billOfMaterials`                                            |
| [`/environments/{{envID}}/apiServers/{{apiServerID}}/operations/{{apiServerOperationID}}`](../../authorize/introduction.html#get-read-api-service-operation) | \* `expand=groups`\* `expand=scopes`\* `expand=authenticationPolicies` |
| [`/environments/{{envID}}/applicationRoles/{{appRoleID}}/users`](../../authorize/application-permissions/application-roles/read-application-role-users.html) | \* `expand=user`                                                       |
| [`/environments/{{envID}}/dataExplorations`](../../mfa/introduction.html#reporting)                                                                          | \* `expand=entries`                                                    |
| [`/environments/{{envID}}/fido2Policies`](../../mfa/introduction.html#fido-policies)                                                                         | \* `expand=deviceAuthenticationPolicies`                               |
| [`/environments/{{envID}}/identityProviders/{{providerID}}`](../identity-provider-management/identity-providers/read-one-identity-provider.html)             | \* `expand=attributes`                                                 |
| [`/resources`](../resources/resources-1/read-all-resources.html)                                                                                             | \* `expand=scopes`                                                     |
| [`/resources/{{resourceID}}`](../resources/resources-1/read-one-resource.html)                                                                               | \* `expand=scopes`                                                     |
| [`/schemas/{{schemaID}}`](../schemas/read-one-schema.html)                                                                                                   | \* `expand=attributes`                                                 |
| [`/users`](../users/users-1/read-all-users.html)                                                                                                             | \* `expand=populations`                                                |
| [`/users/{{userID}}`](../users/users-1/read-one-user.html)                                                                                                   | \* `expand=populations`                                                |
| [`/users/{{userID}}/devices`](../../mfa/introduction.html#mfa-devices)                                                                                       | \* `expand=order`\* `expand=typeDisplayNames`                          |
| [`/users/{{userID}}/linkedAccounts`](../users/linked-accounts/read-linked-accounts.html)                                                                     | \* `expand=identityProviders`                                          |
| [`/users/{{userID}}/linkedAccounts/{{linkedAccountID}}`](../users/linked-accounts/read-one-linked-account.html)                                              | \* `expand=identityProvider`                                           |
| [`/users/{{userID}}/password`](../users/user-passwords/read-password-state.html)                                                                             | \* `expand=passwordPolicy`                                             |

## Endpoints that support ordering by attribute

The following endpoint operations support resource expansion using the `order={attribute}` filter.

| Endpoint                                                                                                  | Attribute                                |
| --------------------------------------------------------------------------------------------------------- | ---------------------------------------- |
| [`/activeIdentityCounts`](../active-identity-counts/read-active-identity-counts-by-date-range.html)       | \* `order=startDate`                     |
| [`/licenses`](../licenses/read-all-licenses.html)                                                         | \* `order=beginsAt`                      |
| [`/templates`](../notifications/notifications-templates/read-all-templates.html)                          | \* `order=updatedAt`\* `order=createdAt` |
| [`/templates/{{templateName}}/contents`](../notifications/notifications-templates/read-all-contents.html) | \* `order=updatedAt`\* `order=createdAt` |

## Endpoints that support page limits

The following endpoint operations support page limits using the `limit` filter. Refer to [Paging and ordering collections](paging-ordering-collections.html) for more information.

* [`GET {{apiPath}}/v1/environments/{{envID}}/applicationRoles/{{appRoleID}}/users`](../../authorize/application-permissions/application-roles/read-application-role-users.html)(1-1024 inclusive)

* [`GET {{apiPath}}/v1/environments`](../environments/read-all-environments.html) (only `organization.id` and `limit` are provided, or only `license.id` and `limit` are provided)

* [`GET {{apiPath}}/v1/environments/{{envID}}/activities`](../user-activities/read-user-activities.html)

* [`GET {{apiPath}}/v1/environments/{{envID}}/applicationSignons`](../authentications-per-application/read-authentications-per-application.html)

* [`POST {{apiPath}}/v1/environments/{{envID}}/dataExplorations?expand=entries`](../../mfa/introduction.html#reporting) (1-1000)

* [`GET {{apiPath}}/v1/environments/{{envID}}/dataExplorations/{{dataExplorationID}}/entries`](../../mfa/introduction.html#reporting) (1-1000)

* [`GET {{apiPath}}/v1/environments/{{envID}}/users`](../users/users-1/read-all-users.html) (1-1000)

* [`GET {{apiPath}}/v1/environments/{{envID}}/populations`](../populations/read-all-populations.html)

* [`GET {{apiPath}}/v1/environments/{{envID}}/activeIdentityCounts`](../active-identity-counts/read-active-identity-counts-by-date-range.html) (1-100)

* [`GET {{apiPath}}/v1/environments/{{envID}}/templates`](../notifications/notifications-templates/read-all-templates.html)

* [`GET {{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents`](../notifications/notifications-templates/read-all-contents.html)

* [`GET {{apiPath}}/v1/environments/{{envID}}/groups`](../groups/read-all-groups.html) (1-1000)

|   |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| - | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|   | For some requests, allowed limits are not always honored by the response. For example, the page size in the `/environments/{{envID}}/users` endpoint response may be smaller than the requested limit. Although limits up to 1000 are permitted for backward compatibility, a requested limit from 201 to 1000 will result in a response page size of 200. When determining the number of records returned per page, use the page size in the response rather than the requested limit. |
